## SaveMeTenMinutes :: docker-compose (AMP/ELK/TICK)+ web development docker-compose stack

### A docker-compose stack containing some of the most popular services related to web development

The stack contains:    
  - AMP stack
    - Apache HTTPd ([http://httpd.apache.org/](http://httpd.apache.org/))
    - MariaDB ([https://mariadb.org/](https://mariadb.org/))
    - MySQL ([https://www.mysql.com/](https://www.mysql.com/))
    - PHP-FPM ([https://www.php.net/](https://www.php.net/), [https://php-fpm.org/](https://php-fpm.org/))
  - A number of MVC frameworks, CMS, eCommerce platforms, admin tools including:
    - Zend Framework 3 ([https://framework.zend.com/](https://framework.zend.com/))
    - Zend Expressive 3 ([https://docs.zendframework.com/zend-expressive/](https://docs.zendframework.com/zend-expressive/))
    - Symfony 4 ([https://symfony.com/](https://symfony.com/))
    - Laravel 6 ([https://laravel.com/](https://laravel.com/))
    - Laravel 6 + Voyager ([https://voyager.devdojo.com/](https://voyager.devdojo.com/))
    - Yii 2 ([https://www.yiiframework.com/](https://www.yiiframework.com/))
    - CakePHP 3 ([https://cakephp.org/](https://cakephp.org/))
    - CodeIgniter 4 ([https://codeigniter.com/](https://codeigniter.com/))
    - Joomla 3 ([https://www.joomla.org/](https://www.joomla.org/))
    - Joomla 4 ([https://developer.joomla.org/news/790-joomla-4-is-on-the-horizon-alpha-11.html](https://developer.joomla.org/news/790-joomla-4-is-on-the-horizon-alpha-11.html))
    - WordPress 5 ([https://wordpress.org/](https://wordpress.org/))
    - Drupal 8 ([https://www.drupal.org/](https://www.drupal.org/))
    - Magento 2 ([https://magento.com/products/magento-open-source](https://magento.com/products/magento-open-source))
    - phpMyAdmin ([https://www.phpmyadmin.net/](https://www.phpmyadmin.net/))
    - phpRedisAdmin ([https://github.com/erikdubbelboer/phpRedisAdmin](https://github.com/erikdubbelboer/phpRedisAdmin))
    - MantisBT ([http://www.mantisbt.org/](http://www.mantisbt.org/))
    - MediaWiki ([https://www.mediawiki.org/](https://www.mediawiki.org/))
  - Elastic (ELK) stack
    - ElasticSearch ([https://www.elastic.co/products/elasticsearch](https://www.elastic.co/products/elasticsearch))
    - Logstash ([https://www.elastic.co/products/logstash](https://www.elastic.co/products/logstash))
    - Kibana ([https://www.elastic.co/products/kibana](https://www.elastic.co/products/kibana))
    - Beats ([https://www.elastic.co/products/beats](https://www.elastic.co/products/beats))
      - Filebeat ([https://www.elastic.co/products/beats/filebeat](https://www.elastic.co/products/beats/filebeat))
      - Metricbeat ([https://www.elastic.co/products/beats/metricbeat](https://www.elastic.co/products/beats/metricbeat))
      - Packetbeat ([https://www.elastic.co/products/beats/packetbeat](https://www.elastic.co/products/beats/packetbeat))
      - Auditbeat ([https://www.elastic.co/products/beats/auditbeat](https://www.elastic.co/products/beats/auditbeat))
      - Heartbeat ([https://www.elastic.co/products/beats/heartbeat](https://www.elastic.co/products/beats/heartbeat))
  - TICK stack
    - Telegraf ([https://www.influxdata.com/time-series-platform/telegraf/](https://www.influxdata.com/time-series-platform/telegraf/))
    - InfluxDB ([https://www.influxdata.com/products/influxdb-overview/](https://www.influxdata.com/products/influxdb-overview/))
    - Chronograf ([https://www.influxdata.com/time-series-platform/chronograf/](https://www.influxdata.com/time-series-platform/chronograf/))
    - Kapacitor ([https://www.influxdata.com/time-series-platform/kapacitor/](https://www.influxdata.com/time-series-platform/kapacitor/))
  - MeaN stack
    - MongoDB ([https://www.mongodb.com/](https://www.mongodb.com/))
    - Node.js ([https://nodejs.org/en/](https://nodejs.org/en/))
  - A number of CI/CD tools including:
    - Bamboo Server ([https://www.atlassian.com/software/bamboo](https://www.atlassian.com/software/bamboo))
    - Bamboo Agent
    - Jenkins ([https://jenkins.io/](https://jenkins.io/))
  - A number of plain Linux OS distro containers for various cross-platform tests including:
    - CentOS 7 ([https://www.centos.org/](https://www.centos.org/))
    - CentOS 8 ([https://www.centos.org/](https://www.centos.org/))
    - Debian 9 "Stretch" ([https://wiki.debian.org/DebianStretch](https://wiki.debian.org/DebianStretch))
    - Debian 10 "Buster" ([https://wiki.debian.org/DebianBuster](https://wiki.debian.org/DebianBuster))
    - Ubuntu 18.10 "Cosmic Cuttlefish" ([https://wiki.ubuntu.com/CosmicCuttlefish/ReleaseNotes](https://wiki.ubuntu.com/CosmicCuttlefish/ReleaseNotes))
    - Ubuntu 19.10 "Eoan Ermine" ([https://wiki.ubuntu.com/EoanErmine](https://wiki.ubuntu.com/EoanErmine))
    - Alpine 3 ([https://alpinelinux.org/](https://alpinelinux.org/))
    - Oracle Linux 7 ([https://www.oracle.com/linux/](https://www.oracle.com/linux/))
    - Oracle Linux 8 ([https://www.oracle.com/linux/](https://www.oracle.com/linux/))
    - OpenSUSE Leap ([https://www.opensuse.org/](https://www.opensuse.org/))
    - OpenSUSE Tumbleweed ([https://www.opensuse.org/](https://www.opensuse.org/))
  - Others
    - Traefik ([https://traefik.io/](https://traefik.io/))
    - Portainer ([https://www.portainer.io/](https://www.portainer.io/))
    - HAProxy ([http://www.haproxy.org/](http://www.haproxy.org/))
    - Redis ([https://redis.io/](https://redis.io/))
    - PostgreSQL ([https://www.postgresql.org/](https://www.postgresql.org/))
    - Nginx ([https://nginx.org/en/](https://nginx.org/en/))
    - Nginx Unit ([https://www.nginx.com/products/nginx-unit/](https://www.nginx.com/products/nginx-unit/))
    - Fluxbox+X11VNC ([http://fluxbox.org/](http://fluxbox.org/), [http://www.karlrunge.com/x11vnc/](http://www.karlrunge.com/x11vnc/))
    - Borg Backup ([https://borgbackup.readthedocs.io/en/stable/](https://borgbackup.readthedocs.io/en/stable/))
    - Integration tests container with Selenium, PhantomJS, CasperJS, SlimerJS, Chrome, Firefox, Insomnia HTTP Client, Fluxbox, X11VNC installed
    - Postfix with MySQL integration ([http://www.postfix.org/](http://www.postfix.org/))
    - Dovecot with MySQL integration ([https://www.dovecot.org/](https://www.dovecot.org/))
    - Apache Tomcat ([http://tomcat.apache.org/](http://tomcat.apache.org/))
    - Apache Cassandra ([http://cassandra.apache.org/](http://cassandra.apache.org/))
    - Apache Kafka ([https://kafka.apache.org/](https://kafka.apache.org/))
    - RabbitMQ ([https://www.rabbitmq.com/](https://www.rabbitmq.com/))
    - Ansible ([https://www.ansible.com/](https://www.ansible.com/))
    - AWX ([https://github.com/ansible/awx](https://github.com/ansible/awx))
    - Apache Maven ([https://maven.apache.org/](https://maven.apache.org/))
    - Redmine ([https://www.redmine.org/](https://www.redmine.org/))
    - XWiki ([https://www.xwiki.org/](https://www.xwiki.org/))
    - Grafana ([https://grafana.com/](https://grafana.com/))
    - Sonarqube ([https://www.sonarqube.org/](https://www.sonarqube.org/))
    - OpenJDK ([https://openjdk.java.net/](https://openjdk.java.net/))
    - Python ([https://www.python.org/](https://www.python.org/))
    - OpenAPI GUI for creating OpenAPI specifications ([https://github.com/Mermade/openapi-gui](https://github.com/Mermade/openapi-gui))
    - OpenAPI generator ([https://github.com/OpenAPITools/openapi-generator](https://github.com/OpenAPITools/openapi-generator))
    - JSDetox ([https://github.com/svent/jsdetox](https://github.com/svent/jsdetox))

Features:    
  - The container entrypoints launch _supervisord_ ([http://supervisord.org/](http://supervisord.org/)) as the main service.
  - Most of the containers are equipped with a running OpenSSH service to aid with development.

1. Prerequisites:    
    1.1. The compose file uses version 3.7 syntax so the following Docker engine/compose requirements must be met:    
        - Docker engine 18.06.0+ ([https://docs.docker.com/compose/compose-file/compose-versioning/#compatibility-matrix](https://docs.docker.com/compose/compose-file/compose-versioning/#compatibility-matrix))    
        - Docker compose 1.22.0+ ([https://docs.docker.com/release-notes/docker-compose/#1220](https://docs.docker.com/release-notes/docker-compose/#1220))    
2. Deploy:    
    2.1. `git clone --recurse-submodules git@gitlab.com:savemetenminutes-root/amp/deployment/docker.git savemetenminutes-docker-stack && cd savemetenminutes-docker-stack`    
    2.2. (Optionally) Checkout the default remote tracking branches of each submodule recursively:    
  `git submodule foreach -q --recursive 'git checkout $(git config -f $toplevel/.gitmodules submodule.$name.branch || echo master)'`    
3. Configure:    
    3.1. `cp .env.dist .env` (modify the _.env_ file according to your needs)    
4. Start:    
    4.1. `./hehe.sh up`    
5. Usage:    
    5.1. The host-facing service ports for each container start at the port as defined in the _&lt;docker-PORT-IP_ADDRESS_LAST_OCTET-SERVICE_NAME&gt;.yml_ file name.    
    5.2. List of services:    
    
| Service                                            | Container Name                              | Last Octet of Container IP Address | Homepage                                                                       | Local URL 0                               | Local URL 1                    | Local URL 2                                                              | Local URL 3                                         | Local URL 4                              | Local URL 5                                     | Local URL 6                                   | Local URL 7                                          |
|----------------------------------------------------|---------------------------------------------|------------------------------------|--------------------------------------------------------------------------------|-------------------------------------------|--------------------------------|--------------------------------------------------------------------------|-----------------------------------------------------|------------------------------------------|-------------------------------------------------|-----------------------------------------------|------------------------------------------------------|
| Ansible                                            | ${COMPOSE_PROJECT_NAME}-ansible             | 4                                  | https://www.ansible.com/                                                       | Supervisor Web UI: http://127.0.0.1:4001  | SSH: 127.0.0.1:4022            |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| AWX (Web)                                          | ${COMPOSE_PROJECT_NAME}-awx_web             | 5                                  | https://github.com/ansible/awx                                                 | Supervisor Web UI: http://127.0.0.1:5001  | SSH: 127.0.0.1:5022            | Web UI: http://127.0.0.1:5052/                                           | Web UI (TLS): http://127.0.0.1:5053/                |                                          |                                                 |                                               |                                                      |
| AWX (Task)                                         | ${COMPOSE_PROJECT_NAME}-awx_task            | 6                                  | https://github.com/ansible/awx                                                 | Supervisor Web UI: http://127.0.0.1:6001  | SSH: 127.0.0.1:6022            |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| AWX (PostgreSQL)                                   | ${COMPOSE_PROJECT_NAME}-awx_postgres        | 7                                  | https://github.com/ansible/awx                                                 | Supervisor Web UI: http://127.0.0.1:7001  | SSH: 127.0.0.1:7022            | Socket: 127.0.0.1:7054                                                   |                                                     |                                          |                                                 |                                               |                                                      |
| AWX (RabbitMQ)                                     | ${COMPOSE_PROJECT_NAME}-awx_rabbitmq        | 8                                  | https://github.com/ansible/awx                                                 | Supervisor Web UI: http://127.0.0.1:8001  | SSH: 127.0.0.1:8022            | EPMD: 127.0.0.1:8069                                                     | AMQP: 127.0.0.1:8071                                | AMQP (SSL): 127.0.0.1:8072               | Web UI (Management): 127.0.0.1:8077             |                                               |                                                      |
| AWX (Memcached)                                    | ${COMPOSE_PROJECT_NAME}-awx_memcached       | 9                                  | https://github.com/ansible/awx                                                 | Supervisor Web UI: http://127.0.0.1:9001  | SSH: 127.0.0.1:9022            | Socket: 127.0.0.1:9011                                                   |                                                     |                                          |                                                 |                                               |                                                      |
| Portainer                                          | ${COMPOSE_PROJECT_NAME}-portainer           | 100                                | https://www.portainer.io/                                                      | Web UI: http://127.0.0.1:10090/           |                                |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Traefik                                            | ${COMPOSE_PROJECT_NAME}-traefik             | 101                                | https://traefik.io/                                                            | Supervisor Web UI: http://127.0.0.1:10101 | SSH: 127.0.0.1:10122           | Web UI: http://127.0.0.1:10180/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| HAProxy                                            | ${COMPOSE_PROJECT_NAME}-haproxy             | 102                                | http://www.haproxy.org/                                                        | Supervisor Web UI: http://127.0.0.1:10201 | SSH: 127.0.0.1:10222           | HTTP Proxy to Apache HTTPd phpinfo(): http://127.0.0.1:10280/phpinfo.php |                                                     |                                          |                                                 |                                               |                                                      |
| Apache HTTPd 2.4                                   | ${COMPOSE_PROJECT_NAME}-apache24            | 11                                 | http://httpd.apache.org/                                                       | Supervisor Web UI: http://127.0.0.1:11001 | SSH: 127.0.0.1:11022           | Status: http://127.0.0.1:11080/server-status                             | Status (TLS): https://127.0.0.1:11443/server-status | Info: http://127.0.0.1:11080/server-info | Info (TLS): https://127.0.0.1:11443/server-info | phpinfo(): http://127.0.0.1:11080/phpinfo.php | phpinfo() (TLS): https://127.0.0.1:11443/phpinfo.php |
| PHP-FPM 7.3                                        | ${COMPOSE_PROJECT_NAME}-php73-fpm           | 12                                 | https://www.php.net/ https://php-fpm.org/                                      | Supervisor Web UI: http://127.0.0.1:12001 | SSH: 127.0.0.1:12022           | Socket: 127.0.0.1:12090                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| MariaDB                                            | ${COMPOSE_PROJECT_NAME}-mariadb             | 130                                | https://mariadb.org/                                                           | Supervisor Web UI: http://127.0.0.1:13001 | SSH: 127.0.0.1:13022           | Socket: 127.0.0.1:13036                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| MySQL                                              | ${COMPOSE_PROJECT_NAME}-mysql               | 131                                | https://www.mysql.com/                                                         | Supervisor Web UI: http://127.0.0.1:13101 | SSH: 127.0.0.1:13122           | Socket: 127.0.0.1:13136                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| PostgreSQL                                         | ${COMPOSE_PROJECT_NAME}-postgres            | 132                                | https://www.postgresql.org/                                                    | Supervisor Web UI: http://127.0.0.1:13201 | SSH: 127.0.0.1:13222           | Socket: 127.0.0.1:13254                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| MongoDB                                            | ${COMPOSE_PROJECT_NAME}-mongo               | 133                                | https://www.mongodb.com/                                                       | Supervisor Web UI: http://127.0.0.1:13301 | SSH: 127.0.0.1:13322           | Socket: 127.0.0.1:13317                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| Redis                                              | ${COMPOSE_PROJECT_NAME}-redis               | 134                                | https://redis.io/                                                              | Supervisor Web UI: http://127.0.0.1:13401 | SSH: 127.0.0.1:13422           | Socket: 127.0.0.1:13479                                                  |                                                     |                                          |                                                 |                                               |                                                      |
| Telegraf                                           | ${COMPOSE_PROJECT_NAME}-telegraf            | 140                                | https://www.influxdata.com/time-series-platform/telegraf/                      | Supervisor Web UI: http://127.0.0.1:14001 | SSH: 127.0.0.1:14022           | Socket (UDP): 127.0.0.1:14025                                            |                                                     |                                          |                                                 |                                               |                                                      |
| InfluxDB                                           | ${COMPOSE_PROJECT_NAME}-influxdb            | 141                                | https://www.influxdata.com/products/influxdb-overview/                         | Supervisor Web UI: http://127.0.0.1:14101 | SSH: 127.0.0.1:14122           | REST API: 127.0.0.1:14186/                                               |                                                     |                                          |                                                 |                                               |                                                      |
| Chronograf                                         | ${COMPOSE_PROJECT_NAME}-chronograf          | 142                                | https://www.influxdata.com/time-series-platform/chronograf/                    | Supervisor Web UI: http://127.0.0.1:14201 | SSH: 127.0.0.1:14222           | Web UI: http://127.0.0.1:14288/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Kapacitor                                          | ${COMPOSE_PROJECT_NAME}-kapacitor           | 143                                | https://www.influxdata.com/time-series-platform/kapacitor/                     | Supervisor Web UI: http://127.0.0.1:14301 | SSH: 127.0.0.1:14322           | REST API: http://127.0.0.1:14392/                                        |                                                     |                                          |                                                 |                                               |                                                      |
| Elasticsearch                                      | ${COMPOSE_PROJECT_NAME}-elasticsearch       | 150                                | https://www.elastic.co/products/elasticsearch                                  | Supervisor Web UI: http://127.0.0.1:15001 | SSH: 127.0.0.1:15022           | REST API: http://127.0.0.1:15092/                                        | Internode Comm Socket: 127.0.0.1:15093              |                                          |                                                 |                                               |                                                      |
| Logstash                                           | ${COMPOSE_PROJECT_NAME}-logstash            | 151                                | https://www.elastic.co/products/logstash                                       | Supervisor Web UI: http://127.0.0.1:15101 | SSH: 127.0.0.1:15122           | Beats Socket: 127.0.0.1:15154                                            | REST API: http://127.0.0.1:15196                    |                                          |                                                 |                                               |                                                      |
| Kibana                                             | ${COMPOSE_PROJECT_NAME}-kibana              | 152                                | https://www.elastic.co/products/kibana                                         | Supervisor Web UI: http://127.0.0.1:15201 | SSH: 127.0.0.1:15222           | Web UI: http://127.0.0.1:15256/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Filebeat                                           | ${COMPOSE_PROJECT_NAME}-filebeat            | 153                                | https://www.elastic.co/products/beats/filebeat                                 | Supervisor Web UI: http://127.0.0.1:15301 | SSH: 127.0.0.1:15322           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Metricbeat                                         | ${COMPOSE_PROJECT_NAME}-metricbeat          | 154                                | https://www.elastic.co/products/beats/metricbeat                               | Supervisor Web UI: http://127.0.0.1:15401 | SSH: 127.0.0.1:15422           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Packetbeat                                         | ${COMPOSE_PROJECT_NAME}-packetbeat          | 155                                | https://www.elastic.co/products/beats/packetbeat                               | Supervisor Web UI: http://127.0.0.1:15501 | SSH: 127.0.0.1:15522           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Auditbeat                                          | ${COMPOSE_PROJECT_NAME}-auditbeat           | 157                                | https://www.elastic.co/products/beats/auditbeat                                | Supervisor Web UI: http://127.0.0.1:15701 | SSH: 127.0.0.1:15722           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Heartbeat                                          | ${COMPOSE_PROJECT_NAME}-heartbeat           | 158                                | https://www.elastic.co/products/beats/heartbeat                                | Supervisor Web UI: http://127.0.0.1:15801 | SSH: 127.0.0.1:15822           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Postfix                                            | ${COMPOSE_PROJECT_NAME}-postfix             | 160                                | http://www.postfix.org/                                                        | Supervisor Web UI: http://127.0.0.1:16001 | SSH: 127.0.0.1:16022           | SMTP: 127.0.0.1:16025                                                    | SMTP: 127.0.0.1:16052                               | SMTP: 127.0.0.1:16046                    | SMTP: 127.0.0.1:16058                           |                                               |                                                      |
| Dovecot                                            | ${COMPOSE_PROJECT_NAME}-dovecot             | 161                                | https://www.dovecot.org/                                                       | Supervisor Web UI: http://127.0.0.1:16101 | SSH: 127.0.0.1:16122           | POP3: 127.0.0.1:16110                                                    | IMAP: 127.0.0.1:16143                               | IMAP: 127.0.0.1:16193                    | POP3: 127.0.0.1:16195                           |                                               |                                                      |
| SFTP                                               | ${COMPOSE_PROJECT_NAME}-sftp                | 162                                |                                                                                | Supervisor Web UI: http://127.0.0.1:16201 | SSH: 127.0.0.1:16222           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Borg Backup                                        | ${COMPOSE_PROJECT_NAME}-backup_borg         | 163                                | https://borgbackup.readthedocs.io/en/stable/                                   | Supervisor Web UI: http://127.0.0.1:16301 | SSH: 127.0.0.1:16322           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Fluxbox+X11VNC                                     | ${COMPOSE_PROJECT_NAME}-fluxbox-vnc         | 164                                | http://fluxbox.org/ http://www.karlrunge.com/x11vnc/                           | Supervisor Web UI: http://127.0.0.1:16401 | SSH: 127.0.0.1:16422           | VNC: 127.0.0.1:16490                                                     |                                                     |                                          |                                                 |                                               |                                                      |
| CentOS 7                                           | ${COMPOSE_PROJECT_NAME}-centos7             | 170                                | https://www.centos.org/                                                        | Supervisor Web UI: http://127.0.0.1:17001 | SSH: 127.0.0.1:17022           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| CentOS 8                                           | ${COMPOSE_PROJECT_NAME}-centos8             | 171                                |                                                                                |                                           |                                |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Debian 9 "Stretch"                                 | ${COMPOSE_PROJECT_NAME}-debian9_stretch     | 172                                | https://wiki.debian.org/DebianStretch                                          | Supervisor Web UI: http://127.0.0.1:17101 | SSH: 127.0.0.1:17122           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Debian 10 "Buster"                                 | ${COMPOSE_PROJECT_NAME}-debian10_buster     | 173                                | https://wiki.debian.org/DebianBuster                                           | Supervisor Web UI: http://127.0.0.1:17201 | SSH: 127.0.0.1:17222           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Ubuntu 18.10 "Cosmic Cuttlefish"                   | ${COMPOSE_PROJECT_NAME}-ubuntu18_cosmic     | 174                                | https://wiki.ubuntu.com/CosmicCuttlefish/ReleaseNotes                          | Supervisor Web UI: http://127.0.0.1:17301 | SSH: 127.0.0.1:17322           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Ubuntu 19.10 "Eoan Ermine"                         | ${COMPOSE_PROJECT_NAME}-ubuntu19_eoan       | 175                                | https://wiki.ubuntu.com/EoanErmine                                             | Supervisor Web UI: http://127.0.0.1:17401 | SSH: 127.0.0.1:17422           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Alpine Linux 3                                     | ${COMPOSE_PROJECT_NAME}-alpine3             | 176                                | https://alpinelinux.org/                                                       | Supervisor Web UI: http://127.0.0.1:17501 | SSH: 127.0.0.1:17522           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Oracle Linux 7                                     | ${COMPOSE_PROJECT_NAME}-oraclelinux7        | 177                                | https://www.oracle.com/linux/                                                  | Supervisor Web UI: http://127.0.0.1:17601 | SSH: 127.0.0.1:17622           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Oracle Linux 8                                     | ${COMPOSE_PROJECT_NAME}-oraclelinux8        | 178                                | https://www.oracle.com/linux/                                                  | Supervisor Web UI: http://127.0.0.1:17701 | SSH: 127.0.0.1:17722           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| OpenSUSE Leap                                      | ${COMPOSE_PROJECT_NAME}-opensuse_leap       | 179                                | https://www.opensuse.org/                                                      | Supervisor Web UI: http://127.0.0.1:17801 | SSH: 127.0.0.1:17822           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| OpenSUSE Tumbleweed                                | ${COMPOSE_PROJECT_NAME}-opensuse_tumbleweed | 180                                | https://www.opensuse.org/                                                      | Supervisor Web UI: http://127.0.0.1:17901 | SSH: 127.0.0.1:17922           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Node.js 11                                         | ${COMPOSE_PROJECT_NAME}-nodejs11            | 190                                | https://nodejs.org/en/                                                         | Supervisor Web UI: http://127.0.0.1:19001 | SSH: 127.0.0.1:19022           | Node.js Debug Socket: 127.0.0.1:19030                                    |                                                     |                                          |                                                 |                                               |                                                      |
| OpenJDK 14                                         | ${COMPOSE_PROJECT_NAME}-openjdk14           | 191                                | https://openjdk.java.net/                                                      | Supervisor Web UI: http://127.0.0.1:19101 | SSH: 127.0.0.1:19122           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Python 3                                           | ${COMPOSE_PROJECT_NAME}-python3             | 192                                | https://www.python.org/                                                        | Supervisor Web UI: http://127.0.0.1:19201 | SSH: 127.0.0.1:19222           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| nginx 1                                            | ${COMPOSE_PROJECT_NAME}-nginx1              | 200                                | https://nginx.org/en/                                                          | Supervisor Web UI: http://127.0.0.1:20001 | SSH: 127.0.0.1:20022           | Default Homepage: http://127.0.0.1:20080/                                |                                                     |                                          |                                                 |                                               |                                                      |
| nginx Unit 1                                       | ${COMPOSE_PROJECT_NAME}-ngunx-unit1         | 201                                | https://www.nginx.com/products/nginx-unit/                                     | Supervisor Web UI: http://127.0.0.1:20101 | SSH: 127.0.0.1:20122           | phpinfo(): http://127.0.0.1:20180/                                       |                                                     |                                          |                                                 |                                               |                                                      |
| Apache Tomcat                                      | ${COMPOSE_PROJECT_NAME}-tomcat              | 210                                | http://tomcat.apache.org/                                                      | Supervisor Web UI: http://127.0.0.1:21001 | SSH: 127.0.0.1:21022           | Default Homepage: http://127.0.0.1:21080/                                |                                                     |                                          |                                                 |                                               |                                                      |
| Apache Cassandra                                   | ${COMPOSE_PROJECT_NAME}-cassandra           | 211                                | http://cassandra.apache.org/                                                   | Supervisor Web UI: http://127.0.0.1:21101 | SSH: 127.0.0.1:21122           | Internode Comm Socket: 127.0.0.1:21170                                   | Internode Comm Socket (TLS): 127.0.0.1:21171        | JMX: 127.0.0.1:21199                     | CQL: 127.0.0.1:21142                            | API: 127.0.0.1:21160                          |                                                      |
| Apache Kafka                                       | ${COMPOSE_PROJECT_NAME}-kafka               | 212                                | https://kafka.apache.org/                                                      | Supervisor Web UI: http://127.0.0.1:21201 | SSH: 127.0.0.1:21222           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Integration Testing                                | ${COMPOSE_PROJECT_NAME}-test                | 220                                |                                                                                | Supervisor Web UI: http://127.0.0.1:22001 | SSH: 127.0.0.1:22022           | Node.js Debug Socket: 127.0.0.1:22092                                    | VNC: 127.0.0.1:22059                                |                                          |                                                 |                                               |                                                      |
| Bamboo Server                                      | ${COMPOSE_PROJECT_NAME}-bamboo-server       | 221                                | https://www.atlassian.com/software/bamboo                                      | Supervisor Web UI: http://127.0.0.1:22101 | SSH: 127.0.0.1:22122           | Socket: 127.0.0.1:22185                                                  | Broker: 127.0.0.1:22163                             |                                          |                                                 |                                               |                                                      |
| Bamboo Agent                                       | ${COMPOSE_PROJECT_NAME}-bamboo-agent        | 222                                | https://www.atlassian.com/software/bamboo                                      | Supervisor Web UI: http://127.0.0.1:22201 | SSH: 127.0.0.1:22222           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Jenkins                                            | ${COMPOSE_PROJECT_NAME}-jenkins             | 223                                | https://jenkins.io/                                                            | Supervisor Web UI: http://127.0.0.1:22301 | SSH: 127.0.0.1:22322           | Web UI: http://127.0.0.1:22380/                                          | JIRA API: http://127.0.0.1:22350/                   |                                          |                                                 |                                               |                                                      |
| Apache Maven                                       | ${COMPOSE_PROJECT_NAME}-maven               | 224                                | https://maven.apache.org/                                                      | Supervisor Web UI: http://127.0.0.1:22401 | SSH: 127.0.0.1:22422           |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Sonarqube                                          | ${COMPOSE_PROJECT_NAME}-sonarqube           | 225                                | https://www.sonarqube.org/                                                     | Supervisor Web UI: http://127.0.0.1:22501 | SSH: 127.0.0.1:22522           | Web UI: http://127.0.0.1:22590/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Redmine                                            | ${COMPOSE_PROJECT_NAME}-redmine             | 226                                | https://www.redmine.org/                                                       | Supervisor Web UI: http://127.0.0.1:22601 | SSH: 127.0.0.1:22622           | Web UI: http://127.0.0.1:22630/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| XWiki                                              | ${COMPOSE_PROJECT_NAME}-xwiki               | 227                                | https://www.xwiki.org/                                                         | Supervisor Web UI: http://127.0.0.1:22701 | SSH: 127.0.0.1:22722           | Web UI: http://127.0.0.1:22780/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| RabbitMQ                                           | ${COMPOSE_PROJECT_NAME}-rabbitmq            | 23                                 | https://www.rabbitmq.com/                                                      | Supervisor Web UI: http://127.0.0.1:23001 | SSH: 127.0.0.1:23022           | EPMD: 127.0.0.1:23369                                                    | AMQP: 127.0.0.1:23671                               | AMQP (SSL): 127.0.0.1:23672              | Web UI (Management): 127.0.0.1:23572            |                                               |                                                      |
| OpenAPI GUI                                        | ${COMPOSE_PROJECT_NAME}-openapi-gui         | 240                                | https://github.com/Mermade/openapi-gui                                         | Supervisor Web UI: http://127.0.0.1:24001 | SSH: 127.0.0.1:24022           | Web UI: http://127.0.0.1:24030/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| OpenAPI Generator                                  | ${COMPOSE_PROJECT_NAME}-openapigenerator    | 241                                | https://github.com/OpenAPITools/openapi-generator                              | Supervisor Web UI: http://127.0.0.1:24101 | SSH: 127.0.0.1:24122           | Server Stub: http://127.0.0.1:24180/                                     |                                                     |                                          |                                                 |                                               |                                                      |
| JSDetox                                            | ${COMPOSE_PROJECT_NAME}-jsdetox             | 242                                | https://github.com/svent/jsdetox                                               | Supervisor Web UI: http://127.0.0.1:24201 | SSH: 127.0.0.1:24222           | Web UI: http://127.0.0.1:24230/                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Grafana                                            | ${COMPOSE_PROJECT_NAME}-grafana             | 25                                 | https://grafana.com/                                                           | Supervisor Web UI: http://127.0.0.1:25001 | SSH: 127.0.0.1:25022           | Web UI: http://127.0.0.1:25030/                                          |                                                     |                                          |                                                 |                                               |                                                      |
|                                                    |                                             |                                    |                                                                                |                                           |                                |                                                                          |                                                     |                                          |                                                 |                                               |                                                      |
| Zend Expressive 3 + Online Marketing Assistant Bot |                                             |                                    |                                                                                | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11401                                         | Homepage (TLS): https://127.0.0.1:11441             |                                          |                                                 |                                               |                                                      |
| phpRedisAdmin                                      |                                             |                                    | https://github.com/erikdubbelboer/phpRedisAdmin                                | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11051                                         | Homepage (TLS): https://127.0.0.1:11451             |                                          |                                                 |                                               |                                                      |
| phpMyAdmin                                         |                                             |                                    | https://www.phpmyadmin.net/                                                    | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11601                                         | Homepage (TLS): https://127.0.0.1:11461             |                                          |                                                 |                                               |                                                      |
| Zend Framework 3                                   |                                             |                                    | https://framework.zend.com/                                                    | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11701                                         | Homepage (TLS): https://127.0.0.1:11471             |                                          |                                                 |                                               |                                                      |
| Zend Expressive 3                                  |                                             |                                    | https://docs.zendframework.com/zend-expressive/                                | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11801                                         | Homepage (TLS): https://127.0.0.1:11481             |                                          |                                                 |                                               |                                                      |
| Symfony 4                                          |                                             |                                    | https://symfony.com/                                                           | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11901                                         | Homepage (TLS): https://127.0.0.1:11491             |                                          |                                                 |                                               |                                                      |
| Laravel 6                                          |                                             |                                    | https://laravel.com/                                                           | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11001                                         | Homepage (TLS): https://127.0.0.1:11501             |                                          |                                                 |                                               |                                                      |
| Laravel 6 + Voyager                                |                                             |                                    | https://voyager.devdojo.com/                                                   | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11002                                         | Homepage (TLS): https://127.0.0.1:11502             |                                          |                                                 |                                               |                                                      |
| Joomla 3                                           |                                             |                                    | https://www.joomla.org/                                                        | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11003                                         | Homepage (TLS): https://127.0.0.1:11503             |                                          |                                                 |                                               |                                                      |
| Joomla 4                                           |                                             |                                    | https://developer.joomla.org/news/790-joomla-4-is-on-the-horizon-alpha-11.html | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11004                                         | Homepage (TLS): https://127.0.0.1:11504             |                                          |                                                 |                                               |                                                      |
| WordPress 5                                        |                                             |                                    | https://wordpress.org/                                                         | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11005                                         | Homepage (TLS): https://127.0.0.1:11505             |                                          |                                                 |                                               |                                                      |
| Drupal 8                                           |                                             |                                    | https://www.drupal.org/                                                        | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11006                                         | Homepage (TLS): https://127.0.0.1:11506             |                                          |                                                 |                                               |                                                      |
| Magento 2                                          |                                             |                                    | https://magento.com/products/magento-open-source                               | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11007                                         | Homepage (TLS): https://127.0.0.1:11507             |                                          |                                                 |                                               |                                                      |
| Yii 2                                              |                                             |                                    | https://www.yiiframework.com/                                                  | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11008                                         | Homepage (TLS): https://127.0.0.1:11508             |                                          |                                                 |                                               |                                                      |
| CakePHP 3                                          |                                             |                                    | https://cakephp.org/                                                           | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11009                                         | Homepage (TLS): https://127.0.0.1:11509             |                                          |                                                 |                                               |                                                      |
| CodeIgniter 4                                      |                                             |                                    | https://codeigniter.com/                                                       | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11010                                         | Homepage (TLS): https://127.0.0.1:11510             |                                          |                                                 |                                               |                                                      |
| MantisBT                                           |                                             |                                    | http://www.mantisbt.org/                                                       | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11011                                         | Homepage (TLS): https://127.0.0.1:11511             |                                          |                                                 |                                               |                                                      |
| MediaWiki                                          |                                             |                                    | https://www.mediawiki.org/                                                     | SSH (Apache HTTPd): 127.0.0.1:11022       | SSH (PHP-FPM): 127.0.0.1:12022 | Homepage: http://127.0.0.1:11012                                         | Homepage (TLS): https://127.0.0.1:11512             |                                          |                                                 |                                               |                                                      |
    
TODO:    
  - Decouple the per-app volumes from the docker-11000-11-apache24.yml and docker-12000-12-php73-fpm.yml files.    
  - Since on Debian 9 (Stretch) the `mysql-client` package uses the `default-mysql-client` dependency which gets its 
  binaries from `mariadb-client-10.1` and since MariaDB 10.1 has not yet implemented the new password hashing plugin of 
  MySQL 8, attempts to communicate with a MySQL 8 server with these MariaDB client binaries (say `mysqladmin` or 
  `mysql`) will result in the following error:
  ```
  ERROR 2059 (HY000): Authentication plugin 'caching_sha2_password' cannot be loaded: /usr/lib/x86_64-linux-gnu/mariadb18/plugin/caching_sha2_password.so: cannot open shared object file: No such file or directory
  ```    
  To work around this problem, the binaries `mysql` and `mysqladmin` have been manually copied from the MySQL container 
  and mounted onto containers which need to communicate with the MySQL 8 instance in the `/usr/local/bin` directory. 
  A better approach might be to build the `mysql-client` binaries from source on container build time.
